/****************************************************************
 *                                                              *
 *  (C)  The TriTechnologies Company, 1991                      *
 *  	      	   	     	       	    	      	   	*
 *       This software is furnished under a license and may     *
 *       be used and copied only in accordance with the terms   *
 *       of such license and with the inclusion of the above    *
 *       copyright notice.  this software or any other copies   *
 *       thereof may not be provided or otherwise made avail-   *
 *       able to any other person.  No title to and ownership   *
 *       of the software is hereby transferred.                 *
 *                                                              *
 *       The information in this software is subject to change  *
 *       without notice and should not be construed as a        *
 *       commitment by The TriTechnologies Company.             *
 ****************************************************************
 *
 * Facility:
 *
 *     kbdfunc.c
 *
 * Abstract:
 *
 *       kbdfunc.c implements the routines called in kbdmain.c 
 */

#include "pcthread.h"
#include "kbd.h"

boolean_t          char_present = false, reader_active = false;
pcthread_cond_t    rd_cond;
pcthread_mutex_t   rd_lock;

extern   unsigned kcount( void );
 
void rd_action()
{
    char ch;
    int ctx, count = 0;
    
    pcthread_cond_init( (pcthread_cond_t *) &rd_cond,
                        pcthread_condattr_default );
                        
    pcthread_mutex_init( (pcthread_mutex_t *) &rd_lock,
                         pcthread_mutexattr_default );

    /*
     * This begins the main loop.  The reader thread locks the rd_lock
     * mutex and then tests the char_present flag.  Depending on its state
     * the reader thread either waits at rd_cond or dives and and retrieves
     * the character.
     */

    pcthread_mutex_lock( (pcthread_mutex_t *) &rd_lock );

    for( ;; )
    {
         while( !char_present )
         {
              reader_active = false;
              pcthread_cond_wait( ( pcthread_cond_t * )  &rd_cond,
                                  ( pcthread_mutex_t * ) &rd_lock );
         }                             

         /*
          * We've been signaled that there is a character to be read
          * from the keyboard input buffer.
          */
          
         reader_active = true;

         ctx = pcthread_disable_preemption_ns( );
         ch = getche();
         pcthread_enable_preemption_ns( ctx );

         count = kcount();
         char_present = false;
    }
}


void
signal_reader()
/*
 * Action:
 *
 *  This routine is called from the keyboard interrupt, 09h.  As such it
 *  executes within the context of the interrupted thread.
 */
{
    pcthread_mutex_lock( (pcthread_mutex_t *) &rd_lock );

    if( reader_active == false )
    {
         char_present = true;
         pcthread_cond_signal( (pcthread_cond_t *) &rd_cond );
    }

    pcthread_mutex_unlock( (pcthread_mutex_t *) &rd_lock );
}