/****************************************************************
 *                                                              *
 *  (C)  The TriTechnologies Company, 1991                      *
 *  	      	   	     	       	    	      	   	*
 *       This software is furnished under a license and may     *
 *       be used and copied only in accordance with the terms   *
 *       of such license and with the inclusion of the above    *
 *       copyright notice.  this software or any other copies   *
 *       thereof may not be provided or otherwise made avail-   *
 *       able to any other person.  No title to and ownership   *
 *       of the software is hereby transferred.                 *
 *                                                              *
 *       The information in this software is subject to change  *
 *       without notice and should not be construed as a        *
 *       commitment by The TriTechnologies Company.             *
 ****************************************************************
 *
 * Facility:
 *
 *     kbdmain.c
 *
 * Abstract:
 *
 *       kbdmain.c is the main program that illustrates the use
 *       of routines to implement simple asynchronouse keyboard I/O
 */

#include "pcthread.h"
#include "kbd.h"

extern void rd_action( void );
extern void signal_thread( void );

pcthread_attr_t    th_attr;
pcthread_t         reader_th;

main()
{
    unsigned long sum = 0;    
    unsigned max_p, i, j;

    /*
     * Hook the keyboard hardware interrupt
     */
     
    install_ISR9();
    
    /*
     * Set up the attributes object for the reader thread.  Note that
     * we make the reader thread execute at the maximum permissable
     * priority.
     */
     
    (void) pcthread_attr_create( (pcthread_attr_t *) &th_attr );
    max_p = pcthread_attr_getmaxprio_ns();
    (void) pcthread_attr_setprio( (pcthread_attr_t *) &th_attr, max_p );
    i = pcthread_setactive_prio_ns( max_p - 1 );            


    (void) pcthread_create(  (pcthread_t *) &reader_th,
                             th_attr,
                             (pcthread_action_t) rd_action,
                             (pcthread_addr_t *) 0 );

    /*
     * Soak up some cycles between the user's keystrokes.
     */

    pcthread_enable_trace_ns();

    for(i = 0; i < 30000; i++ )
         for(j = 0; j < 100; j++ )
              sum = i + j;
     
    remove_ISR9();
    pcthread_disable_trace_ns();
    pcthread_close_ns( "rd.c",                   /* module name */
                       "main()",                 /* calling function */
                       "Success",                /* User specific message */
                       execution_normal_e );     /* exception code */
    
    return( 0 );
}