/*
 * Test10.c    --   Test of pcthread_exit()
 */
 
#include <stdlib.h>
#include <stdio.h>
#include "pcthread.h"

typedef
    struct FOO
    {
         int  a;
         int  b;
         int  sum;
    }    foo_t;

/*
 * Globally static variables
 */

#define THREADS 3
static pcthread_t       hello_th[THREADS], foo_th;
static pcthread_attr_t  th_attr_handle;
static foo_t            foo;
    
/*
 * Function prototypes
 */

static void create_foo( void );
static void retrieve_foo( void );

static int arg;

main()
{
    int i;

    (void) pcthread_attr_create( (pcthread_attr_t *) &th_attr_handle );

    (void) pcthread_attr_setstacksize( 
              (pcthread_attr_t *) &th_attr_handle, 1024 );

    for( i = 0; i < THREADS; i++ )
    (void) pcthread_create(  (pcthread_t *) &hello_th[i],
                             th_attr_handle, 
                             (pcthread_action_t) retrieve_foo,
                             (pcthread_addr_t *) &arg);


    (void) pcthread_attr_setstacksize( 
              (pcthread_attr_t *) &th_attr_handle, 512 );

    (void) pcthread_create(  (pcthread_t *) &foo_th,
                             th_attr_handle, 
                             (pcthread_action_t) create_foo,
                             (pcthread_addr_t *) &arg );

    pcthread_yield();

    return;
}

static void
retrieve_foo()
{
    foo_t *bar;
    pcthread_addr_t status;
    int  ctx;
    
    (void) pcthread_join( (pcthread_t *) &foo_th, 
                          (pcthread_addr_t *) &status );

    bar = (foo_t *) status;

    ctx = pcthread_disable_preemption_ns();
    printf("bar->a = %d, bar->b = %d, bar->sum = %d\n", 
         bar->a, bar->b, bar->sum );
    pcthread_enable_preemption_ns( ctx );
}

static void
create_foo()
{
    foo.a = 1;
    foo.b = 2;
    foo.sum = foo.a + foo.b;

    pcthread_exit( (pcthread_addr_t) &foo );
}