/*
 * Test13.c --  A test of pcthread_setprio()
 */
 
#include <stdlib.h>
#include <stdio.h>
#include "pcthread.h"

#define N 10

static pcthread_t       **child_th, *initial_th;
static pcthread_attr_t  th_attr_handle;

static void null_task( void );
static int    dummy;

main()
{
    int i, max_p, def_p;
    
    child_th = ( pcthread_t **) malloc( N * sizeof( pcthread_t *));
    for(i = 0; i < N; i++ )
         child_th[i] = (pcthread_t *) malloc( sizeof( pcthread_t ));

    /*
     * Elevate the creating thread's priority then create a bunch of threads.
     * When this loop completes, N threads will be randomly distributed 
     * throughout the ready queue.
     */
     
    initial_th = pcthread_self();
    max_p = pcthread_attr_getmaxprio_ns();
    
    (void) pcthread_attr_create( (pcthread_attr_t *) &th_attr_handle );

    (void) pcthread_attr_setstacksize( 
              (pcthread_attr_t *) &th_attr_handle, 1024 );

    for(i = 0; i < N; i++ )
    {
         (void) pcthread_create(  child_th[i], 
                                  th_attr_handle, 
                                  (pcthread_action_t) null_task,
                                  (pcthread_addr_t *) &dummy );

         def_p = rand() % max_p;
         (void) pcthread_setprio( child_th[i], def_p );
    }
 
    /*
     * Lower the initial thread's priority.  This will cause the resident
     * threads on the ready queue to execute.
     */
     
    (void) pcthread_setprio( initial_th, 1 );    

    return 0;
}

void
null_task()
{
    pcthread_t *th_handle;
    int p, ctx;

    th_handle = pcthread_self();
    p = pcthread_getprio( th_handle );        

    ctx = pcthread_disable_preemption_ns();
    printf("Thread[%u], priority %d complete...\n", th_handle->object_id, p );
    pcthread_enable_preemption_ns( ctx );
    
    return;
}