/*
 * Test18.c 
 */

#include "pcthread.h"

static pcthread_t       th_handle;
static pcthread_mutex_t mu_handle;
static pcthread_cond_t  cv_handle;
static boolean_t        complete = false;

void
thread_action( void )
{
    int status = 0;

    (void) pcthread_mutex_lock( (pcthread_mutex_t *) &mu_handle );
    complete = true;
    (void) pcthread_mutex_unlock( (pcthread_mutex_t *) &mu_handle );

    status = pcthread_cond_signal( (pcthread_cond_t *) &cv_handle );
}

main()
{
    int dummy = 0, status = 0;

    (void) pcthread_mutex_init( (pcthread_mutex_t *) &mu_handle, 
                                 pcthread_mutexattr_default );

    status = pcthread_cond_init( (pcthread_cond_t *) &cv_handle,
                                 pcthread_condattr_default );

    (void) pcthread_create( (pcthread_t *) &th_handle,
                                  pcthread_attr_default,
                                  (pcthread_action_t) thread_action,
                                  (pcthread_addr_t *) &dummy );


    (void) pcthread_mutex_lock( ( pcthread_mutex_t *) &mu_handle );

    while( complete == false )
         status = pcthread_cond_wait( (pcthread_cond_t *) &cv_handle,
                                      (pcthread_mutex_t *) &mu_handle );

    (void) pcthread_mutex_unlock( (pcthread_mutex_t *) &mu_handle );

    pcthread_mutex_printdata_ns( mu_handle );

    return ( status );
}
