/*
 * Test5.c --  A test to obtain the performance of pcthread_create().
 */
 
#include <stdlib.h>
#include <stdio.h>
#include "pcthread.h"

#define THREADS 10

static pcthread_t       **child_th, test_th;
static pcthread_attr_t  th_attr_handle;

static void test_task( void );
static void null_task( void );

static int    dummy;

main()
{
    int i;

    /*
     * Preallocate the thread handles for the threads that will execute
     * the null_task.
     */
     
    child_th = ( pcthread_t **) malloc( THREADS * sizeof( pcthread_t *));
    for(i = 0; i < THREADS; i++ )
         child_th[i] = (pcthread_t *) malloc( sizeof( pcthread_t ));

    /*
     * The test generator thread and each of the child threads do not 
     * need alot of stack space.  Hence, set the thread attributes object
     * such that 128 words are allocated to each thread -- The minimum 
     * allowable stacksize.
     */
     
    (void) pcthread_attr_create( (pcthread_attr_t *) &th_attr_handle );
    (void) pcthread_attr_setstacksize( (pcthread_attr_t *) 
                                       &th_attr_handle, 128 );

    /*
     * Create, and join with, the test generator thread.  We will return from
     * pcthread_join() when the test generator thread completes.
     */

    (void) pcthread_create(  (pcthread_t *) &test_th, 
                             th_attr_handle, 
                             (pcthread_action_t) test_task,
                             (pcthread_addr_t *) &dummy );

    (void) pcthread_join( (pcthread_t *) &test_th, (pcthread_addr_t *) &dummy );
    
    return;
}

void
test_task()
{
    int i;

    /*
     * This action routine creates the threads that execute the null_task.
     * It yields to each one so they execute immediately upon creation.
     */

    for(i = 0; i < THREADS; i++ )
    {
         (void) pcthread_create(  child_th[i], 
                                  th_attr_handle, 
                                  (pcthread_action_t) null_task,
                                  (pcthread_addr_t *) &dummy );

         (void) pcthread_yield();
    }
}

void
null_task()
{
    return;
}