/*
 * Test6.c
 */
 
#include <stdlib.h>
#include <stdio.h>
#include "pcthread.h"

#define THREADS 10

static pcthread_t       child_th1, **child_th2;
static pcthread_attr_t  th_attr_handle;

void say_hello( void );
void compute( void );

static int    dummy;

main()
{
    int i;
    
    child_th2 = (pcthread_t **) malloc( THREADS*sizeof(pcthread_t *));

    for(i = 0; i < THREADS; i++ )
         child_th2[i] = (pcthread_t *) malloc( sizeof( pcthread_t ));

    (void) pcthread_attr_create( (pcthread_attr_t *) &th_attr_handle );

    pcthread_attr_setstacksize( (pcthread_attr_t *) &th_attr_handle, 128 );
    for(i = 0; i < THREADS; i++ )
    {
         (void) pcthread_create(  child_th2[i], 
                                  th_attr_handle, 
                                  (pcthread_action_t) compute,
                                  (pcthread_addr_t *) &dummy );

         pcthread_yield();
    }
    
    (void) pcthread_attr_setstacksize(
              (pcthread_attr_t *) &th_attr_handle, 1024);

    (void) pcthread_create(  (pcthread_t *) &child_th1, 
                             th_attr_handle, 
                             (pcthread_action_t) say_hello,
                             (pcthread_addr_t *) &dummy );

    return;
}

void
say_hello()
{
    pcthread_t *th_handle;
    int  ctx;
    
    th_handle = pcthread_self();

    ctx = pcthread_disable_preemption_ns();
    printf("Hello world from Thread[%u]\n", th_handle->object_id );
    pcthread_enable_preemption_ns( ctx );
}

void
compute()
{
    int i;
    unsigned long sum = 0;    

    for(i = 0; i < 10000; i++ )
         sum += i;
}