/****************************************************************
 *  (C)  The TriTechnologies Company, 1991                      *
 *  	      	   	     	       	    	      	   	*
 *       This software is furnished under a license and may     *
 *       be used and copied only in accordance with the terms   *
 *       of such license and with the inclusion of the above    *
 *       copyright notice.  this software or any other copies   *
 *       thereof may not be provided or otherwise made avail-   *
 *       able to any other person.  No title to and ownership   *
 *       of the software is hereby transferred.                 *
 *                                                              *
 *       The information in this software is subject to change  *
 *       without notice and should not be construed as a        *
 *       commitment by The TriTechnologies Company.             *
 ****************************************************************
 *
 * Facility:
 *
 *     typedefs.h
 *
 * Abstract:
 *
 *       PCthreads(tm) Application Programming Interface, API.
 *       The definitions provided in this interface are required
 *       by the pcthreads API.
 */

#ifndef _TYPEDEFS_H
#define _TYPEDEFS_H

/*
 * typedefs.h
 */

typedef unsigned*         pcthread_addr_t;
typedef pcthread_addr_t   (*pcthread_action_t)();

typedef
    enum RESULT
    {
         ttc_c_operation_failed = -1,
         ttc_c_operation_succeeded = 0
    }                                  result_t;
    
typedef 
    enum BOOLEAN 
    { 
         false, 
         true 
    }    	   boolean_t;

typedef 
    enum ANSWER
    {
         no,
         yes
    }               answer_t;

typedef 
    enum SCHEDULING_POLICY
    {
         schedule_error_c = -1,
         fcfs_c = 0,                        /* Default sched policy */
         round_robin_c = 1,  
         priority_decay_c = 2
    }                             policy_t;

typedef 
    enum OBJECTS 
    {
        object_error_c = -1,
        null_object_c = 0,
        pcthread_attr_c = 1,
        mutex_attr_c = 2,
        cond_attr_c = 3,
        pcthread_c = 4,
        mutex_c = 5,
        cond_c = 6
    }                        object_t;








typedef
    enum PROTOCOL
    {
         protocol_error_c = -1,
         success_c = 0,
         no_prio_inherit_c = 1,
         prio_inherit_c = 2,
         prio_ceiling_c = 3,
         glob_prio_ceiling_c = 4

    }                        pcthread_protocol_t;
    
typedef
    enum EXCEPTION_CODE
    {
         execution_normal_e,           /* No exception taken */
         ctrl_break_e,                 /* User depressed ^C */
         insufficient_memory_e,        /* malloc() returned a NULL */
         alerted_e,                    /* A thread has been alerted */
         existance_e,                  /* An object does not exist */
         usage_error_e,                /* An object is not used properly */
         stack_e,                      /* A major bogosity */
         assert_failed_e,              /* A consistency check failed */
         not_initialized_e             /* init_system() not called */

    }  exception_t;
    
typedef 
    struct HANDLE 
    {
         pcthread_addr_t     *object_ptr;
         object_t            object_type;
         unsigned            object_id;
    }                                  handle_t;

typedef handle_t    pcthread_t;             
typedef handle_t    pcthread_mutex_t;       
typedef handle_t    pcthread_cond_t;        
typedef handle_t    pcthread_attr_t;
typedef handle_t    pcthread_mutexattr_t;
typedef handle_t    pcthread_condattr_t;

#endif
